import { Sidemenu } from './sidemenu';
import { LeafShape, event_callback_response } from '/home/nirudhi/Natrayan/Projects/ETL/nidhajs/lib/nidhajs';
export { NiruChart };
declare class NiruChart {
    chartsidemenu: Sidemenu;
    private chartWidth;
    chartHeight: number;
    private leafmould;
    chart_leafs: any;
    chartsvgid: string;
    private canvas;
    private chartzoom;
    path_id_counter: number;
    leaf_groupid: string;
    con_groupid: string;
    moving_leaf: LeafShape;
    dag_leaf: any;
    leafmould_class: any[];
    chartdata_obj: any;
    sidemenuwidth: number;
    sidemenugelement: string;
    callback_func: Function;
    constructor(width: number, height: number, leafmould_class: any, leafmould: any, leafdata: any, chartsvgid: string, sidemneuwidth: number | undefined, callback_func: Function);
    resize_draw_area(width: number, height: number): void;
    private init_draw_area;
    let_draw_draw(d: any): void;
    drawNode(): void;
    draw_connectors(): void;
    getInstance(className: string, ...args: any[]): any;
    pop_leaf(area: string, obj: LeafShape): void;
    push_leaf(area: string, obj: LeafShape): null;
    set_store_fun(area?: string, func?: (area: string, leaf_obj: LeafShape, char_obj: NiruChart, operation_type?: string) => number): void;
    find_target(area: string, end_obj: LeafShape, port_type?: string): LeafShape;
    myZoom(): void;
    zoom_reset(): void;
    calcGridWH(x: number, y: number): void;
    click_calbk(ev: event_callback_response): void;
    emit_event(ev: event_callback_response): void;
}
