import * as d3 from 'd3';
import { Sidemenu } from './sidemenu';
import { Mouldtype, MappingChartdata, Mouldconfigs } from './niruchart_models';
import { LeafShape, base_circle_leaf, event_callback_response } from '/home/nirudhi/Natrayan/Projects/ETL/nidhajs/lib/nidhajs';
//import { LeafShape, base_circle_leaf, event_callback_response } from 'nidhajs';

import { NiruChartData } from './niruchart_data';

export { NiruChart };

class NiruChart {

  public chartsidemenu: Sidemenu;
  private chartWidth: number;
  public chartHeight: number;
  private leafmould: Mouldconfigs[]; 
  //private leafdata: saved_Moulds[];
  public chart_leafs: any;
  /*
      { 
        draw_area : {
                      "store_func": Function,
                      "leafs" : any[[],[],...]
                    },
        sidemenu_area : {
                      "store_func": Function,
                      "leafs" : any[[],[],...]
                    }
      }
  */
  //public drawarea_leafs: any[];
  
  //public draw_area_leafs_func: Function;
  //public sidemenu_moulds: Niru.LeafShape[];
  public chartsvgid: string;
  private canvas: any;
  private chartzoom: any;
  public path_id_counter: number;
  public leaf_groupid: string;
  public con_groupid: string;
  public moving_leaf: LeafShape;
  public dag_leaf: any;
  public leafmould_class: any[];
  public chartdata_obj: any;

  public sidemenuwidth: number;
  public sidemenugelement: string;
  public callback_func: Function;
  

    



  constructor(width: number,height: number,leafmould_class=<any>[],leafmould=<any>[],leafdata: any = null,chartsvgid: string,sidemneuwidth: number =0,callback_func: Function) {
      this.chartWidth = width;
      this.chartHeight = height;
      this.leafmould = leafmould;
      this.chartdata_obj = {};      
      this.chartsvgid = chartsvgid;
      this.sidemenuwidth = sidemneuwidth?sidemneuwidth:(this.chartWidth/10);
      this.sidemenugelement = "sidemenuarea";
      this.leaf_groupid = "#leaflayer";
      this.con_groupid = "#connectionslayer";
      this.path_id_counter = 0;
      this.callback_func = callback_func;
      this.chartsidemenu = <Sidemenu>{};
      this.leafmould_class = [];

      this.chart_leafs = {  "draw_area" :     {
                                                "store_func": [],  //index 0 is for leafs, index 1 is for connects
                                                "leafs" : [],
                                                "leaf_connects":[]
                                              },
                            "sidemenu_area" : {
                                                 "store_func": [],
                                                 "leafs" : []
                                               }
                          };
      //this.sidemenu_moulds = [];
      // Initialise the Canvas with 
      this.moving_leaf= <LeafShape>{};
      this.set_store_fun();
      console.log("leafmould_class");
      console.log(leafmould_class);
      this.chartdata_obj = new NiruChartData(leafmould_class,leafmould,leafdata);
      this.init_draw_area();
      this.drawNode();
      this.draw_connectors();
   }

resize_draw_area(width: number,height: number) {
  console.log("width - " + width);
    this.chartWidth = width;
    this.chartHeight = height;
        //this.canvas =  d3.select("#natchartcanvas")
        this.canvas = d3.select(this.chartsvgid)
                        .attr("width",this.chartWidth)
                        .attr("height", this.chartHeight);
}


private init_draw_area() {

  /*
  console.log(this.chartsvgid);
      this.canvas =  d3.select("#" + this.chartsvgid)
                        .attr("width",this.chartWidth)
                        .attr("height", this.chartHeight);
  console.log(this.canvas);
*/

do {
  this.canvas =  d3.select("#" + this.chartsvgid)
                  .attr("width",this.chartWidth)
                  .attr("height", this.chartHeight);
} 
while (this.canvas.empty());

/*
      d3.select("#lea flayer")
        .selectAll("g")
          .data(this.chartdata_obj.dag_data.descendants())
          .enter()
          .append("g")
          .attr("id",(d,i) => {
                                console.log(d);
                                //this.let_draw_draw(d);
                                return "leaf_" + d.id;
                              }  
                              );

      d3.select("#leaflayer")
        .selectAll("g")
          .style("fill-opacity",(d)=> {this.let_draw_draw(d); return 1;});                  
*/
      this.chartzoom = d3.zoom()
                          .scaleExtent([1, 8])
                          .on("zoom",(d)=>this.myZoom());

      let drawarea = this.canvas.append("g").attr("id","drawarea");

      let mygrid = d3.select('#drawarea').append('rect')
      //let mygrid =  this.canvas.append('rect')
        .attr("id","gridarea")
        //.attr('x', this.sidemenuwidth)
        //.attr('y', '-50%')
        .attr('width', '410%')
        .attr('height', '410%')
        .attr('fill', 'url(#grid)');


      /* Create the below groups and have their reference       
        <g id ="drawarea">
          <g  id="connectionslayer">  </g>
          <g  id="leaflayer" class=""> </g>
        </g>
      */

      




      let grid_canvas =  //this.canvas
                      mygrid
                      .call(this.chartzoom);              
                      //.select("#drawarea");

      let leaflayer = drawarea.append("g").attr("id","leaflayer");
      let connlayer = drawarea.append("g").attr("id","connectionslayer");
      this.chartsidemenu = new Sidemenu(this); 
}

let_draw_draw(d: any) {
    console.log("let_draw_draw");
    console.log(d);
    console.log("g#leaf_"+d.data.id,d.data.leaf_d_txt);
    let ddsd = this.getInstance("custom_"+ /*"rect_in_out_port_leaf"*/d.data.mould_conf.mould_class,
    d.data.x,d.data.y,null,"g#leaf_"+d.data.id,d.data.leaf_d_txt,this,d);
    console.log("dddsd");
    console.log(ddsd);
    console.log("dondoendoendoen");
    //"#leaf_"+d.data.id
}

drawNode(){  
  console.log("drawnode mp");
  //d3.selectAll('#nodelayer').raise();
  console.log(this.chartdata_obj.dag_data.descendants());
  //console.log(this.nodelayer);

console.log("-----");
  //@TESTING CODES  
  //let ddsd = new my_rect_leaf(500,200,null,230,60);
//constructor(x:number, y:number, prntshape:any, groupid: string, r: number,t: string[]) {
  //let ddsd = new Niru.custom_rect_leaf(500,200,null,230,60);
  console.log(d3.select("#leaflayer"));
  d3.select("#leaflayer")
    .selectAll("g")
      .data(this.chartdata_obj.dag_data.descendants())
      .enter()
      .append("g")
      .attr("id",(d: any,i) => {
                            console.log("*989898");
                            console.log(d);
                            this.let_draw_draw(d);
                            return "leaf_" + d.id;
                          }  
                          );
  d3.select("#leaflayer")
    .selectAll("g")
      .style("class",(d)=> {this.let_draw_draw(d); return "test";});
}

draw_connectors() {
  console.log("8888");
  console.log(this.chartdata_obj.dag_data.links());
  let lk = this.chartdata_obj.dag_data.links();
  if(lk.length) {
    lk.forEach( (d:any) => {
      console.log("--------------------------");
      console.log(d.source.obj.baseshape);
      let ddsd = this.getInstance("Connectors",d.source.obj.connect_ports.outport[0].baseshape,d.target.obj.connect_ports.inport[0]);
      
    });
  }
  //let ddsd = this.getInstance("connectors",
  console.log("8888");
}

/*
get_path_id() {
return this.path_id_counter += 1;
} 
*/

 getInstance(className: string, ...args: any[]): any {
        // TODO: Handle Null and invalid className arguments
        console.log("getInstance");
        console.log(className);
        console.log(this.chartdata_obj);
        console.log(this.chartdata_obj.mould_classes);
        console.log(this.chartdata_obj.mould_classes[className]);
        const mod: any = this.chartdata_obj.mould_classes;
        console.log(typeof mod[className]);
        if (typeof mod[className] !== undefined) {
          //console.log(mod);
          console.log("000000");
          console.log(className);
          console.log(mod);
          
            return new mod[className](...args);
        } else {
            console.log("else get instance");
            throw new Error("Class not found: " + className);
        }
 }

 pop_leaf(area: string,obj: LeafShape) {
   let index = -1;
   console.log(obj);
   this.chart_leafs[area].leafs[obj.myroot[0].bucket_num].forEach (
     (le: LeafShape,i: number) => {        
       console.log("Popout");   
       console.log(le === obj.myroot[0]) ;
       console.log(i);
        if (le === obj.myroot[0]) {
          index = i;
        }
     });
     if(index>0) {
      this.chart_leafs[area].leafs[obj.myroot[0].bucket_num].splice(index, 1); 
    }
    
    console.log("Popoutend");
 }

push_leaf(area: string,obj: LeafShape) {
  console.log("Popoutpush");
    let bucket_num =  this.chart_leafs[area].store_func[0](area,obj,this,"set");
    let ele_num = null;
    console.log(area);
    console.log(obj.myroot[0]);
    if (obj.myroot[0].bucket_num !== bucket_num) {
      let ele_num = this.chart_leafs[area].leafs[bucket_num].push(obj.myroot[0]);
    }    
    console.log(obj);
    console.log(this.chart_leafs[area].leafs[obj.myroot[0].bucket_num]);
    if(obj.myroot[0].bucket_num !== null && obj.myroot[0].bucket_num !== bucket_num && this.chart_leafs[area].leafs[obj.myroot[0].bucket_num]!== undefined) {
      this.pop_leaf(area,obj);
    }
    obj.myroot[0].bucket_num = bucket_num;
    return ele_num;
}

set_store_fun (area: string = "draw_area" || "sidemenu_area", func = test) {
  //TODO  change this to set at the start
  //console.log(this);
  area = "draw_area";
  this.chart_leafs[area].store_func.splice(0,0,func);
  area = "sidemenu_area";
  this.chart_leafs[area].store_func.splice(0,0,func);
}


find_target(area: string,end_obj: LeafShape,port_type: string = "in") {

  let target_node = <LeafShape>{};

  
  
  let bucket_num =  this.chart_leafs[area].store_func[0](area,end_obj,this,"get");
  let port = "";
  (port_type === "out") ? port = "outport" : port = "inport";
  console.log(this.chart_leafs);
  console.log("target_called");
  console.log(bucket_num);
  console.log(end_obj);
  console.log(this.chart_leafs[area].leafs);
  this.chart_leafs[area].leafs[bucket_num]
    .forEach ( 
        (node: LeafShape) => {      
                    node.connect_ports[port]
                      .forEach (
                        (nodeeac: LeafShape) => {
                                      
                                      let obj_x = end_obj.get_x();
                                      let obj_y = end_obj.get_y();
                                      let x = nodeeac.get_x();
                                      let y = nodeeac.get_y();
                                      let rad = (<base_circle_leaf>nodeeac.baseshape).radius;
                                      let x_min = x - rad;
                                      let x_max = x + rad;
                                      let y_min = y - rad;
                                      let y_max = y + rad;
                                      console.log("----target");
                                      console.log(nodeeac);
                                      console.log(end_obj);
                                      console.log("x" + x);
                                      console.log("y" + y);
                                      console.log("radius" + rad);
                                      console.log("obj_x" + obj_x);
                                      console.log("obj_y" + obj_y);
                                      console.log("x_max" + x_max);
                                      console.log("x_min" + x_min);
                                      console.log("x_max" + x_max);
                                      console.log("y_min" + y_min);
                                      console.log("y_max" + y_max);
                                      console.log("----target");

                                      if (obj_x > x_min && obj_x < x_max ) { //check whether horizontally in
                                        if (obj_y > y_min && obj_y < y_max) {
                                                target_node = nodeeac.baseshape;                
                                        } 
                                      }
                        })
      });
  console.log("before_return");
  console.log(target_node);
  return target_node;
}

  myZoom() {
      let transform = d3.event.transform;
      //console.log("------");
      //console.log(transform.k);
      //console.log( parseInt(this.canvas.select('#gridarea').attr("x")));
      //console.log(parseInt(transform.k));
      //console.log("old x = " +  this.canvas.select('#gridarea').attr("x") + " new x =" + (parseFloat(transform.x) + (parseFloat(this.canvas.select('#gridarea').attr("x")) * parseFloat(transform.k))));
     // let new_x = ((parseFloat(transform.x) * parseFloat(transform.k)) + (parseFloat(this.canvas.select('#gridarea').attr("x")) * parseFloat(transform.k)));
      //console.log("x - " + transform.x, " y - " + transform.y);

      transform.x = Math.min(0,Math.min(0,parseFloat(transform.x)));  // Stop pan beyond x=0
      //transform.x = transform.x;  // Stop pan beyond x=0
      transform.y = Math.min(0,Math.max(0,parseFloat(transform.y)) );  // Stop pan beyond y=0
      //transform.y = 0; 
      //this.canvas.attr("transform", transform.toString()); 
      //console.log("x - " + transform.x + " y - " + transform.y);
     // console.log(this.canvas.select('#natchartcanvas'));
      
      let tt = transform.toString()
      //console.log("here", d3.event.translate, d3.event.scale);
      this.canvas.select('#drawarea').attr("transform", tt);
      //this.canvas.select('#gridarea').attr("transform", tt);
                                    //.attr("x", new_x);

      this.calcGridWH(transform.x,transform.y);
      //d3.select("#lmenu").raise();

  }

  zoom_reset() {
    console.log("d");
    this.canvas.transition().call(this.chartzoom.transform, d3.zoomIdentity);
    this.canvas.transition().select('#drawarea').call(this.chartzoom.transform, d3.zoomIdentity);
  }

  calcGridWH(x: number,y: number) {
  let girdarea = this.canvas.select('#gridarea');
  let nx = x>0?x:x*-1;
  //console.log(x);
  if (y <0) {
    girdarea.attr('height', Math.max(410, y*-1).toString() + "%");
  }
  if (x <0) {
    girdarea.attr('width', Math.max(2000, x*-1).toString() + "%");
  }

}

click_calbk(ev: event_callback_response) {
  switch(ev.event_code) {
    case("menu-btn-clk"): {
      this.emit_event(ev);
      break;
    }
  }
}

emit_event(ev: event_callback_response) {
  console.log("get it");
  this.callback_func(ev);
}

}

//This function to be set from calling append
// if not set take this as default
let test = function (area: string,leaf_obj: LeafShape,char_obj: NiruChart,operation_type: string = "get") {
  let bucket = Math.floor((leaf_obj.get_x())/100);
  //Add missing buckets
  if (operation_type = "set"){
    if (typeof(char_obj.chart_leafs[area].leafs[bucket]) === "undefined") {
      if(bucket === 0 ) {
        char_obj.chart_leafs[area].leafs.push([]);
      } else {
        for (let i = 0; i <= bucket; i++) {        
          if (typeof(char_obj.chart_leafs[area].leafs[i]) === "undefined") {
            char_obj.chart_leafs[area].leafs.push([]);
          }
        }
      }
    }
  }
  return bucket;
}

