export interface Mouldtype {
    mouldGroup: string;   //io,stringoperation,numoperation,etc...
    moduleId: string;
    submoduleId: string;
    mouldId: string;
  }
  
  export interface MappingChartdata {
      id: string;
      x: number;
      y: number;
      leaf_d_txt: any[];
      mould_conf: any,
      parentIds: string[];
      nodedata: any;
  }
  
  
  export interface Mouldconfigs {
      mouldType: Mouldtype;
      dispname: string;
      mould_class: string;
      // Array to take values for multiple object in the mould_class.  
      // Implementation in the nidhajs_niruchart_shapes
      color_config: any ; // which will have Mouldcolorconf details for port etc.;   
      //This is to hold the form
      mould_form: any;  
  }
  
  export interface Mouldcolorconf {
      fill: string;
      stroke: string;
      stroke_width : number;
  }
  
  /*
  export interface saved_Moulds {
      id: string;
      x: number;
      y: number;
      mouldType: Mouldtype;
      parentIds: string[];
      nodedata: any;
  }
  */
  
  
    
    
  